/**
 * AN EXTERNAL JS FILE FOR CAMPAIGNS DISPLAYED ON PAGES ACROSS OLB-R WEB APPLICATION
 */
function displayOffer() {
	var viewName = getDisplayedPageViewName();
	var campaignForm = jQuery('.campaignPageForm');

	var offerInputDetails = {
		'viewName' : viewName
	}

	 $.ajax({
            url: campaignForm.attr("action"),
            type: 'post',
            dataType: 'json',
            data: offerInputDetails,
            beforeSend:function(){$(".Slot_F1 , .Slot_F2 , .Slot_F3").attr('tabIndex' ,'-1');},
            success: function (offerResponse) {
            	
            	if(offerResponse != null) {
            		// Iterate through the offers
            		for (i = 0; i < offerResponse.length; i++) { 
						 var offerLocationClass = "." + offerResponse[i]['location'];
						 var offerType = offerResponse[i]['offerType'];
						 var campaignToBePlaced;
						 var targetUrl = "";
						 var footerSlots = ['.Slot_F1' , '.Slot_F2' , '.Slot_F3'];						 
						 var found = ('indexOf' in Array.prototype) ? (footerSlots.indexOf(offerLocationClass)>-1): (jQuery.inArray(offerLocationClass, footerSlots)>-1);						 
						 if(found){
						 	$(offerLocationClass.toString()).removeAttr('tabIndex');
						 }
						 if(offerResponse[i]['targetUrl']){
							 //This will allow us navigate to both http:// and https:// domains, we don't accept simple www external pages
							 if(offerResponse[i]['targetUrl'].indexOf("http") >= 0 || offerResponse[i]['targetUrl'].indexOf("olb-web") >= 0){ // this will consider the http:// option
								 targetUrl = offerResponse[i]['targetUrl'];
							 }
							 else if(offerResponse[i]['targetUrl'].indexOf("https") >= 0 || offerResponse[i]['targetUrl'].indexOf("olb-web") >= 0){// this will consider the https:// option
								 targetUrl = offerResponse[i]['targetUrl'];
							 }
							 else
								 targetUrl = "/olb-web" + offerResponse[i]['targetUrl'];
							 //targetUrl = (offerResponse[i]['targetUrl'].indexOf("www") >= 0 || offerResponse[i]['targetUrl'].indexOf("olb-web") >= 0 ) ? offerResponse[i]['targetUrl'] : "/olb-web"+offerResponse[i]['targetUrl'];
						 }

						 // Once the offer is displayed, removing the tabIndex to add them back in tabbing.
						 $(offerLocationClass.toString()).show();
						 if(targetUrl){
							 $(offerLocationClass.toString()).attr({"href": targetUrl, "onclick": "sendOfferResponse('" + offerResponse[i]["name"] + "', 'Clicked');"});
						 }
						 else{
							 //Copy the original Class values to the Div which has no <a> tag.
							 var clasValues = $(offerLocationClass.toString()).attr( "class" );
							 $(offerLocationClass.toString()).replaceWith('<div class=' + clasValues + '/>');
						 }
						 
						 if(offerResponse[i]["newWindow"] != 'No'){
							$(offerLocationClass.toString()).attr({"target": "_blank"});
						 }
						  
						 // Banner Type Campaign Types
						 if(offerType === "Banner"){
							 $(offerLocationClass.toString()).parent().removeClass("none");
						 	// Offer type is an image, so create and append the image to the slot location and add the href.
						 	campaignToBePlaced = $("<img />", {'height': 'auto','width': 'auto','src': offerResponse[i]['offerUrl'], 'alt': offerResponse[i]['altDisplayTxt']});						 	
						 	$(offerLocationClass.toString()).append(campaignToBePlaced);						 	
						 }
						 
						 // Text & IW2 type Campaign Types
						 else if(offerType === 'Text' || offerType === 'IW2'){ 	
						 	$(offerLocationClass.toString()).parent().removeClass("none");
						 	$(offerLocationClass.toString()).html(offerResponse[i]["textCampaignDisplayVal"]);
						 } 
												 
	        	    } // End of the loop
            	
            	} // End of IF block
            }
        });
	    
	}

// Function to send the User Response Back to Epiphany
function sendOfferResponse(offerName, acceptanceLevel) {
	var viewName = getDisplayedPageViewName();
	var campaignResponseForm = jQuery('.campaignResponsePageForm');
	
	var offerInputDetails = {
		'viewName' : viewName,
		'offerName' : offerName,
		'acceptanceLevel' : acceptanceLevel
	}
	$.map($(".campaignResponsePageForm").serializeArray(), function(n, i) {
		offerInputDetails[n.name] = n.value;		
	});
	$.ajax({
		url : campaignResponseForm.attr("action"),
		type : 'post',
		dataType : 'json',
		data : offerInputDetails,
		success : function(offerResponse) {}
	});
}


// This method returns the page name of the current displayed page
function getDisplayedPageViewName() {
	var displayUrl = document.URL;
	var viewName = displayUrl.split("/");
	viewName = viewName[viewName.length - 1];
	viewName = viewName.split("?")[0];
	viewName = viewName.replace(/[#\s]/gi, '');
	return viewName;
}

