

if (!window.LL_Deployment) {
    LL_Deployment = { };
    LL_Deployment.mainServerPath = "www.livelook.com";
}

if (!LL_Deployment.FM) {
    LL_Deployment.FM = { };
}

LL_Deployment.FM.isLookupByClassEnabled = "true";
LL_Deployment.FM.ltbUrls = "";
LL_Deployment.FM.ltbUrlsExc = "";
LL_Deployment.FM.elementsArray = "";
LL_Deployment.FM.borderWidth = 2;

var __ll__ = function () {
    // Global temporary object for handling DOM node insertion
    var tempEl = document.createElement("DIV");

    // Matches dashed string for camelizing
    var rdashAlpha = /-([a-z]|[0-9])/ig;
    var rmsPrefix = /^-ms-/;

    // Exclude the following css properties to add px
    var cssNumber = {
        "fillOpacity": true,
        "fontWeight": true,
        "lineHeight": true,
        "opacity": true,
        "orphans": true,
        "widows": true,
        "zIndex": true,
        "zoom": true
    };

    // Useragent RegExp
    var rwebkit = /(webkit)[ \/]([\w.]+)/,
	    ropera = /(opera)(?:.*version)?[ \/]([\w.]+)/,
	    rmsie = /(msie) ([\w.]+)/,
	    rmozilla = /(mozilla)(?:.*? rv:([\w.]+))?/;

    /**
     * Used by camelCase as callback to replace()
     * @private
     */
    function fcamelCase(all, letter) {
        return (letter + "").toUpperCase();
    }

    /**
     * Convert dashed to camelCase; used by the css and data modules
     * Microsoft forgot to hump their vendor prefix
     * @private
     */
    function camelCase(string) {
        return string.replace(rmsPrefix, "ms-").replace(rdashAlpha, fcamelCase);
    }

    /**
     * Gets elements by classname. Uses native methods when possible
     * @private
     */
    var getElementsByClassName = function () {
        // native 
        if (document.getElementsByClassName) {
            return function (className, nodeName, parentElement) {
                var s = (parentElement || document).getElementsByClassName(className);

                if (nodeName && nodeName != '*') {
                    nodeName = nodeName.toUpperCase();
                    return Array.filter(s, function (el) { return el.nodeName == nodeName; });
                }
                else
                    return [].slice.call(s, 0);
            }
        }

        // xpath 
        if (document.evaluate) {
            return function (className, nodeName, parentElement) {
                if (!nodeName) nodeName = '*';
                if (!parentElement) parentElement = document;

                var results = [], s, i = 0, element;

                s = document.evaluate(
                    ".//" + nodeName + "[contains(concat(' ', @class, ' '), ' " + className + " ')]",
                    parentElement,
                    null,
                    XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,
                    null
                );

                while ((element = s.snapshotItem(i++)))
                    results.push(element);

                return results;
            }
        }

        // generic 
        return function (className, nodeName, parentElement) {
            if (!nodeName) nodeName = '*';
            if (!parentElement) parentElement = document;

            var results = [], s, i = 0, element;
            var re = new RegExp('(^|\\s)' + className + '(\\s|$)'), elementClassName;

            s = parentElement.getElementsByTagName(nodeName);

            while ((element = s[i++])) {
                if ((elementClassName = element.className) &&
                    (elementClassName == className || re.test(elementClassName))
                )
                    results.push(element);
            }

            return results;
        }
    }();


    var UrlPattern = function (strPattern) {
        var patternStr;

        var protocol;
        var host;
        var path;
        var query;
        var ref;
        var params;

        var NULL_OBJECT = "&NULL&";

        var _init = function (str) {
            patternStr = str.toLowerCase();

            var index = patternStr.indexOf("://");
            protocol = patternStr.substring(0, index);
            patternStr = "http" + patternStr.substring(index);

            index = patternStr.indexOf("/", 7);
            if (index != -1) {
                host = patternStr.substring(7, index);
                patternStr = "http://domain" + patternStr.substring(index);
            }
            else {
                host = patternStr.substring(7);
                patternStr = "http://domain";
            }

            var a = document.createElement("a");
            a.href = patternStr;

            // host = unescape(a.hostname);
            path = a.pathname;
            if (path && path.indexOf("/") == 0) {
                path = path.substring(1);
            }
            if (path.length == 0) {
                path = null;
            }
            query = a.search;
            if (query && query.indexOf("?") == 0) {
                query = query.substring(1);
            }
            ref = a.hash;
            if (ref && ref.indexOf("#") == 0) {
                ref = ref.substring(1);
            }

            params = _parseParams(query);

            //console.log(protocol + ", " + host + ", " + path + ", " + query + ", " + ref + ", " + JSON.stringify(params));
        };

        var match = function (str) {
            var _pattern = new __ll__.UrlPattern(str);

            if (query == null || query.length == 0 || "*" == query || "+" == query) {
                if (!_equalsWithWildcard(query, _pattern.query)) {
                    return false;
                }
            }
            else {
                if (_pattern.params != null) {
                    for (var key in params) {
                        if (typeof _pattern.params[key] == "undefined") {
                            return false;
                        }
                        if (!_equalsWithWildcard(params[key], _pattern.params[key])) {
                            return false;
                        }
                    }
                }
                else {
                    return false;
                }
            }

            var result = _equalsWithWildcard(protocol, _pattern.protocol) &&
				_equalsHostWithWildcard(host, _pattern.host) &&
				_equalsWithWildcard(path, _pattern.path) &&
				_equalsWithWildcard(ref, _pattern.ref);

            return result;
        };

        var _parseParams = function (str) {
            if (!str) {
                return null;
            }

            var params = {};
            var arraySplitedByAmp = str.split("&");

            var delim = "&";
            for (var i = 0; i < arraySplitedByAmp.length; i++) {
                var token = arraySplitedByAmp[i];
                var ind = token.indexOf("=");
                if (ind != -1) {
                    var key = token.substring(0, ind);
                    var value = token.substring(ind + 1);
                    params[key] = value;
                }
                else {
                    params[token] = NULL_OBJECT;
                }
            }

            return params;
        };

        var _equalsHostWithWildcard = function (pattern, str) {
            var result = _equalsWithWildcard(pattern, str);
            if (!result && _startsWith(pattern, "*.") == 0) {
                result = _equalsWithWildcard(pattern, "." + str);
            }

            return result;
        };

        var _equalsWithWildcard = function (pattern, str) {
            if (pattern == null && str == null) {
                return true;
            }

            if (str == null && "*" == pattern) {
                return true;
            }

            if (str == null || pattern == null) {
                return false;
            }

            if (pattern == "*") {
                return true;
            }

            if (_startsWith(pattern, "*")) {
                return _endsWith(str, pattern.substring(1));
            }

            if (_endsWith(pattern, "*")) {
                return _startsWith(str, pattern.substring(0, pattern.length - 1));
            }

            if (_startsWith(pattern, "+")) {
                return _endsWith(str, pattern.substring(1)) && str.length > pattern.length - 1;
            }

            if (_endsWith(pattern, "+")) {
                return _startsWith(str, pattern.substring(0, pattern.length - 1)) &&
					str.length > pattern.length - 1;
            }

            return pattern == str;
        };

        var _endsWith = function (str, suffix) {
            return str.lastIndexOf(suffix) + suffix.length == str.length;
        };

        var _startsWith = function (str, prefix) {
            return str.indexOf(prefix) == 0;
        };

        var _instance = (function () {
            _init(strPattern);

            return {
                protocol: protocol,
                host: host,
                path: path,
                query: query,
                ref: ref,
                params: params,
                match: match
            };
        })();

        return _instance;
    };

    /***********************************************************************************/

    var onReadyListeners = [];
    var readyCalled = false;
    return {
        /**
		 * Subroutine to find a DOM node(s) with given selector
		 * @param selector: Selector of the element which should be found
		 * @public
		 */
        $: function (selector) {
            // Handle $(""), $(null), or $(undefined)
            if (!selector) {
                return selector;
            }

            // Handle $(DOMElement)
            if (selector.nodeType) {
                return selector;
            }

            if (typeof selector === "string") {
                selector = __ll__.trim(selector);

                // Are we dealing with HTML string or an ID?
                if (selector.charAt(0) === "<" &&
			         selector.charAt(selector.length - 1) === ">" &&
			         selector.length >= 3) {// HANDLE: __ll__.$("<h1>test</h1>")

                    tempEl.innerHTML = selector;
                    var fEl = tempEl.childNodes[0];
                    if (fEl) {
                        document.body.appendChild(fEl);
                        return fEl;
                    }
                } else if (selector.charAt(0) == ".") {// HANDLE: __ll__.$(".classname")
                    selector = selector.substr(1);
                    return getElementsByClassName(selector);
                } else {
                    if (selector.charAt(0) == "#") {// HANDLE: __ll__.$("#id")
                        selector = selector.substr(1);
                    }

                    return document.getElementById(selector);
                }
            }
        },

        /**
		 * Subroutine to initialize __ll__ object. Gets called after DOM load
		 * @public
		 */
        ready: function () {
            if (readyCalled) return;
            readyCalled = true;

            var mode = document.compatMode, m;
            if (mode) {
                if (mode == "BackCompat")
                    m = "Quirks";
                else if (mode == "CSS1Compat")
                    m = "Standards Compliance";
                else
                    m = "Almost Standards Compliance";
            }

            __ll__.boxModel = m != "Quirks";

            for (var i = 0; i < onReadyListeners.length; i++) {
                try {
                    onReadyListeners[i].apply(window, []);
                } catch (ex) { }
            }
        },

        browser: {},

        /**
		 * Cross browser event attaching subroutine
		 * @param evnt: Event name like click, mousedown, keydown etc.
		 * @param elem: Element on which handler will be assigned
		 * @param func: Event handler
		 * @public
		 */
        listen: function (evnt, elem, func) {
            if (elem == null)
                return;

            if (evnt == "ready") {
                onReadyListeners.push(func);
                return;
            }

            if (elem.addEventListener)  // W3C DOM
                elem.addEventListener(evnt, func, false);
            else if (elem.attachEvent) { // IE DOM
                elem.attachEvent("on" + evnt, func);
            }
        },

        /**
		 * Cross browser DOM node remove function
		 * @param selector: Selector of the element which should be deleted
		 * @public
		 */
        remove: function (selector) {
            try {
                var node = __ll__.$(selector);
                if (node && node.parentNode) {
                    node.parentNode.removeChild(node);
                }
            } catch (ex) { }
        },

        /**
		 * Get and set the style property on a DOM Node
		 * @param selector: Selector of the element
		 * @param css: CSS collection to set, or css attribute name to return
		 * @public
		 */
        css: function (selector, css) {
            var node = __ll__.$(selector), type, value;
            if (!node || !node.nodeType)
                return;

            if (typeof css == "string") {// HANDLE: __ll__.css(node, "position")
                value = __ll__.curCSS(node, css);
                if ((cssNumber[css] || css == "width" || css == "height") && !isNaN(parseInt(value)))
                    return parseInt(value);

                return value;
            } else {
                for (var name in css) {
                    value = css[name];
                    type = typeof value;

                    // Make sure that NaN and null values aren't set. See: #7116
                    if (value == null || type === "number" && isNaN(value)) {
                        continue;
                    }

                    origName = camelCase(name)

                    // If a number was passed in, add 'px' to the (except for certain CSS properties)
                    if (type === "number" && (!cssNumber[origName] || name == "width" || name == "height")) {
                        value += "px";
                    }

                    node.style[origName] = value;
                }
            }
        },

        /**
		 * Removes whitespaces from tail and head
		 * @param str: String to trim
		 * @public
		 */
        trim: function (str) {
            return str.replace(/^\s+|\s+$/g, '');
        },

        /**
		 * Matches browser by provided user agent string
		 * @param ua: User agent string to match the browser
		 * @public
		 */
        uaMatch: function (ua) {
            ua = ua.toLowerCase();

            var match = rwebkit.exec(ua) ||
			    ropera.exec(ua) ||
			    rmsie.exec(ua) ||
			    ua.indexOf("compatible") < 0 && rmozilla.exec(ua) ||
			    [];

            return { browser: match[1] || "", version: match[2] || "0" };
        },

        /**
		 * Initilizes element position detection engine
		 * @public
		*/
        initializeOffset: function () {
            if (__ll__.offset.initialized) return;
            var body = document.body, container = document.createElement('div'), innerDiv, checkDiv, table, td, rules, prop, bodyMarginTop = body.style.marginTop,
				html = '<div style="position:absolute;top:0;left:0;margin:0;border:5px solid #000;padding:0;width:1px;height:1px;"><div></div></div><table style="position:absolute;top:0;left:0;margin:0;border:5px solid #000;padding:0;width:1px;height:1px;" cellpadding="0" cellspacing="0"><tr><td></td></tr></table>';

            rules = { position: 'absolute', top: 0, left: 0, margin: 0, border: 0, width: '1px', height: '1px', visibility: 'hidden' };
            for (prop in rules) container.style[prop] = rules[prop];

            container.innerHTML = html;
            body.insertBefore(container, body.firstChild);
            innerDiv = container.firstChild, checkDiv = innerDiv.firstChild, td = innerDiv.nextSibling.firstChild.firstChild;

            __ll__.offset.doesNotAddBorder = (checkDiv.offsetTop !== 5);
            __ll__.offset.doesAddBorderForTableAndCells = (td.offsetTop === 5);

            innerDiv.style.overflow = 'hidden', innerDiv.style.position = 'relative';
            __ll__.offset.subtractsBorderForOverflowNotVisible = (checkDiv.offsetTop === -5);

            body.style.marginTop = '1px';
            __ll__.offset.doesNotIncludeMarginInBodyOffset = (body.offsetTop === 0);
            body.style.marginTop = bodyMarginTop;

            body.removeChild(container);
            __ll__.offset.initialized = true;
        },

        /**
		 * Detects body offset
		 * @public
		*/
        bodyOffset: function (body) {
            __ll__.offset.initialized || __ll__.initializeOffset();
            var top = body.offsetTop, left = body.offsetLeft;
            if (__ll__.offset.doesNotIncludeMarginInBodyOffset)
                top += parseInt(__ll__.curCSS(body, 'marginTop', true), 10) || 0,
				left += parseInt(__ll__.curCSS(body, 'marginLeft', true), 10) || 0;
            return { top: top, left: left };
        },

        /**
		 * Finds position of the element
		 * @param selector: Selector of the element which position should be found
		 * @public
	    */
        offset: function (selector) {
            var elem = __ll__.$(selector);
            if (!elem) return { top: 0, left: 0 };

            __ll__.offset.initialized || __ll__.initializeOffset();

            try {

                if (document.documentElement["getBoundingClientRect"]) {

                    if (elem === elem.ownerDocument.body) return __ll__.bodyOffset(elem);
                    var box = elem.getBoundingClientRect(), doc = elem.ownerDocument, body = doc.body, docElem = doc.documentElement,
						clientTop = docElem.clientTop || body.clientTop || 0, clientLeft = docElem.clientLeft || body.clientLeft || 0,
						top = box.top + (window.pageYOffset || __ll__.boxModel && docElem.scrollTop || body.scrollTop) - clientTop,
						left = box.left + (window.pageXOffset || __ll__.boxModel && docElem.scrollLeft || body.scrollLeft) - clientLeft;


                    if (__ll__.browser.msie && __ll__.browser.version <= 8.0
							&& document.documentMode == 8
							&& __ll__.offset.doesNotAddBorder) {
                        top -= parseInt(elem.style.borderTopWidth, 10);
                        left -= parseInt(elem.style.borderLeftWidth, 10);
                    }

                    return { top: top, left: left };
                } else {

                    if (elem === elem.ownerDocument.body) return __ll__.bodyOffset(elem);

                    var offsetParent = elem.offsetParent, prevOffsetParent = elem,
						doc = elem.ownerDocument, computedStyle, docElem = doc.documentElement,
						body = doc.body, defaultView = doc.defaultView,
						prevComputedStyle = defaultView.getComputedStyle(elem, null),
						top = elem.offsetTop, left = elem.offsetLeft;

                    while ((elem = elem.parentNode) && elem !== body && elem !== docElem) {
                        computedStyle = defaultView.getComputedStyle(elem, null);
                        top -= elem.scrollTop, left -= elem.scrollLeft;
                        if (elem === offsetParent) {
                            top += elem.offsetTop, left += elem.offsetLeft;
                            if (__ll__.offset.doesNotAddBorder && !(__ll__.offset.doesAddBorderForTableAndCells && /^t(able|d|h)$/i.test(elem.tagName)))
                                top += parseInt(computedStyle.borderTopWidth, 10) || 0,
								left += parseInt(computedStyle.borderLeftWidth, 10) || 0;
                            prevOffsetParent = offsetParent, offsetParent = elem.offsetParent;
                        }
                        if (__ll__.offset.subtractsBorderForOverflowNotVisible && computedStyle.overflow !== "visible")
                            top += parseInt(computedStyle.borderTopWidth, 10) || 0,
							left += parseInt(computedStyle.borderLeftWidth, 10) || 0;
                        prevComputedStyle = computedStyle;
                    }

                    if (prevComputedStyle.position === "relative" || prevComputedStyle.position === "static")
                        top += body.offsetTop,
						left += body.offsetLeft;

                    if (prevComputedStyle.position === "fixed")
                        top += Math.max(docElem.scrollTop, body.scrollTop),
						left += Math.max(docElem.scrollLeft, body.scrollLeft);

                    return { top: top, left: left };
                }
            } catch (ex) {
                return { top: 0, left: 0 };
            }
        },

        /**
		 * Gets computed style value
		 * @public
		*/
        curCSS: function (elem, name, force) {
            var ret, style = elem.style, doc = elem.ownerDocument, defaultView = doc.defaultView;

            // Make sure we're using the right name for getting the float value
            if (name.match(/float/i))
                name = styleFloat;

            if (!force && style && style[name])
                ret = style[name];

            else if (defaultView && defaultView.getComputedStyle) {

                // Only "float" is needed here
                if (name.match(/float/i))
                    name = "float";

                name = name.replace(/([A-Z])/g, "-$1").toLowerCase();

                var computedStyle = defaultView.getComputedStyle(elem, null);

                if (computedStyle)
                    ret = computedStyle.getPropertyValue(name);

                // We should always get a number back from opacity
                if (name == "opacity" && ret == "")
                    ret = "1";

            } else if (elem.currentStyle) {
                var camelCase = name.replace(/\-(\w)/g, function (all, letter) {
                    return letter.toUpperCase();
                });

                ret = elem.currentStyle[name] || elem.currentStyle[camelCase];

                // From the awesome hack by Dean Edwards
                // http://erik.eae.net/archives/2007/07/27/18.54.15/#comment-102291

                // If we're not dealing with a regular pixel number
                // but a number that has a weird ending, we need to convert it to pixels
                if (!/^\d+(px)?$/i.test(ret) && /^\d/.test(ret)) {
                    // Remember the original values
                    var left = style.left, rsLeft = elem.runtimeStyle.left;

                    // Put in the new values to get a computed value out
                    elem.runtimeStyle.left = elem.currentStyle.left;
                    style.left = ret || 0;
                    ret = style.pixelLeft + "px";

                    // Revert the changed values
                    style.left = left;
                    elem.runtimeStyle.left = rsLeft;
                }
            }

            return ret;
        },
		
		isVisible: function (obj) {
			if (obj == document) return true;
			
			if (!obj) return false;
			if (!obj.parentNode) return false;
			if (obj.style) {
				if (obj.style.display == 'none') return false;
				if (obj.style.visibility == 'hidden') return false;
			}
			
			//Try the computed style in a standard way
			if (window.getComputedStyle) {
				var style = window.getComputedStyle(obj, "");
				if (style.display == 'none') return false;
				if (style.visibility == 'hidden') return false;
			}
			
			//Or get the computed style using IE's silly proprietary way
			var style = obj.currentStyle;
			if (style) {
				if (style['display'] == 'none') return false;
				if (style['visibility'] == 'hidden') return false;
			}
			
			return this.isVisible(obj.parentNode);
		},

        UrlPattern: UrlPattern
    }
}();

if (document.documentElement.contains) {
    __ll__.contains = function (a, b) {
        return a !== b && (a.contains ? a.contains(b) : true);
    };

} else if (document.documentElement.compareDocumentPosition) {
    __ll__.contains = function (a, b) {
        return !!(a.compareDocumentPosition(b) & 16);
    };

} else {
    __ll__.contains = function () {
        return false;
    };
}

(function () {
    //Detect browser
    var browserMatch = __ll__.uaMatch(navigator.userAgent);
    if (browserMatch.browser) {
        __ll__.browser[browserMatch.browser] = true;
        __ll__.browser.version = browserMatch.version;
    }

    if (__ll__.browser.webkit) {
        __ll__.browser.safari = true;
    }

    // If Mozilla is used
    if (__ll__.browser.mozilla || __ll__.browser.opera)
        // Use the handy event callback
        document.addEventListener("DOMContentLoaded", __ll__.ready, false);

        // If IE is used, use the excellent hack by Matthias Miller
        // http://www.outofhanwell.com/blog/index.php?title=the_window_onload_problem_revisited
    else if (__ll__.browser.msie) {
        // Only works if you document.write() it
        document.write("<scr" + "ipt id=__ie_init defer=true " +
			"src=//:><\/script>");

        // Use the defer script hack
        var script = document.getElementById("__ie_init");

        // script does not exist if __ll__ is loaded dynamically
        if (script)
            script.onreadystatechange = function () {
                if (this.readyState != "complete") return;
                __ll__.ready();
            };

        // Clear from memory
        script = null;

        // If Safari  is used
    } else if (__ll__.browser.safari)
        // Continually check to see if the document.readyState is valid
        __ll__.safariTimer = setInterval(function () {
            // loaded and complete are both valid states
            if (document.readyState == "loaded" ||
				document.readyState == "complete") {

                // If either one are found, remove the timer
                clearInterval(__ll__.safariTimer);
                __ll__.safariTimer = null;

                // and execute any waiting functions
                __ll__.ready();
            }
        }, 111);

    // A fallback to window.onload, that will always work
    __ll__.listen("load", window, __ll__.ready);
})();

var cssUtils = function(){
 
	return {
		createCSSClass : function(name) {
			var style = document.createElement('style');
			style.type = 'text/css';
			style.innerHTML = '.' + name + ' { border: '+ LiveLookFM.BORDER_WIDTH +'px solid #'+LiveLookFM.BORDER_COLOR+' !important; color: #' + LiveLookFM.TEXT_COLOR + '; outline: 0}';
			document.getElementsByTagName('head')[0].appendChild(style);
			borderClassAlreadyCreated = true;
			
			return style;
		},
		
		removeCSSClass: function(styleElement) {
			if (styleElement && styleElement.parentElement) {
				styleElement.parentElement.removeChild(styleElement);
			}
		},
		
		hasClass : function(ele,cls) {
			return ele.className.match(new RegExp('(\\s|^)'+cls+'(\\s|$)'));
		},
		
		removeClass : function(elements,cls) {
			var elementsCount = elements.length;
			for(var i=0; i<elementsCount; i++) {
				if (cssUtils.hasClass(elements[i],cls)) {
					var reg = new RegExp('(\\s|^)'+cls+'(\\s|$)');
					elements[i].className=elements[i].className.replace(reg,' ');
				}
			}
		}
	}
	
}();


var LiveLookFM = function () {
    var SECURE_ELEMENTS = new Array();

    var POS_FIX_INTERVAL = 111;
    var FIELD_POS_FIX_TIMER = 0;
	var SESSION_STATES = {
		"INIT" : 1,
		"ACTIVE" : 5
	};
	var borderClassAlreadyCreated = false;

    var pageBlockingSupported = false;
    var sectionBlockingSupported = false;

    var urlPatterns = [];
    var urlPatternsExc = [];

    var secureSectionsToBlock = [];

    function fixElementPosition(el) {
        var pos = __ll__.offset(el);

        //if element is already removed or it's position is unknown or it's not visible, skip...
        if (!el || !pos /*|| !__ll__.isVisible(el)*/) // commented by Hayk because with this change borders remain on the page when field become invisible
            return;

		// For non-legacy deployments show the borders only if the session is active
		var isLegacy = function() {
			// Always work like in legacy case until we find a solution with cross-browser sessions.
			//return !window.LL_Deployment || LL_Deployment.release === undefined;
			return true;
		};
		
		if(!isLegacy()) {
			if(window.LL_Session) {
				
				var currentSessionState = LL_Session.currentState.get();
				
				var isACB = function() {
					if(LL_Session.mode == null) {
						return true;
					} else {
						return LL_Session.mode.startsWith("ACB") || LL_Session.pings.currentState.get() === LL_Session.pings.states.ELEVATED;
					}
				}
			
				if((currentSessionState == SESSION_STATES.ACTIVE && isACB()) || currentSessionState == SESSION_STATES.INIT) {
				
					if(!borderClassAlreadyCreated) {
						cssUtils.createCSSClass('llBorderClass');
					}
					
					__ll__.css(el.tApp, {
						position: 'absolute',
						width: el.offsetWidth,// + 2*LiveLookFM.BORDER_WIDTH,
						height: LiveLookFM.BORDER_WIDTH,
						top: pos.top,// - LiveLookFM.BORDER_WIDTH,
						left: pos.left,// - LiveLookFM.BORDER_WIDTH
						zIndex: 2000000000,
						display: 'block'
					});

					__ll__.css(el.bApp, {
						position: 'absolute',
						width: el.offsetWidth,// + 2*LiveLookFM.BORDER_WIDTH,
						height: LiveLookFM.BORDER_WIDTH,
						top: pos.top + el.offsetHeight - LiveLookFM.BORDER_WIDTH,
						left: pos.left,// - LiveLookFM.BORDER_WIDTH
						zIndex: 2000000000,
						display: 'block'
					});

					__ll__.css(el.lApp, {
						position: 'absolute',
						width: LiveLookFM.BORDER_WIDTH,
						height: el.offsetHeight,// + 2*LiveLookFM.BORDER_WIDTH,
						top: pos.top,// - LiveLookFM.BORDER_WIDTH,
						left: pos.left,// - LiveLookFM.BORDER_WIDTH
						zIndex: 2000000000,
						display: 'block'
					});

					__ll__.css(el.rApp, {
						position: 'absolute',
						width: LiveLookFM.BORDER_WIDTH,
						height: el.offsetHeight,// + 2*LiveLookFM.BORDER_WIDTH,
						top: pos.top,// - LiveLookFM.BORDER_WIDTH,
						left: pos.left + el.offsetWidth - LiveLookFM.BORDER_WIDTH,
						zIndex: 2000000000,
						display: 'block'
					});
				} else {
					__ll__.css(el.tApp, {
						display: 'none'
					});

					__ll__.css(el.bApp, {
						display: 'none'
					});

					__ll__.css(el.lApp, {
						display: 'none'
					});

					__ll__.css(el.rApp, {
						display: 'none'
					});
					
					var secureElements = getSecureElements(window.LL_Deployment && LL_Deployment.FM ? LL_Deployment.FM.elementsArray : "");
					
					cssUtils.removeClass(secureElements, "llBorderClass");
					if (typeof LiveLookFM.cssElement != 'undefined') {
						cssUtils.removeCSSClass(LiveLookFM.cssElement);
						delete LiveLookFM.cssElement;
					}
				}
			} 
		} else {
			__ll__.css(el.tApp, {
				position: 'absolute',
				width: el.offsetWidth,// + 2*LiveLookFM.BORDER_WIDTH,
				height: LiveLookFM.BORDER_WIDTH,
				top: pos.top,// - LiveLookFM.BORDER_WIDTH,
				left: pos.left,// - LiveLookFM.BORDER_WIDTH
				zIndex: 2000000000
			});

			__ll__.css(el.bApp, {
				position: 'absolute',
				width: el.offsetWidth,// + 2*LiveLookFM.BORDER_WIDTH,
				height: LiveLookFM.BORDER_WIDTH,
				top: pos.top + el.offsetHeight - LiveLookFM.BORDER_WIDTH,
				left: pos.left,// - LiveLookFM.BORDER_WIDTH
				zIndex: 2000000000
			});

			__ll__.css(el.lApp, {
				position: 'absolute',
				width: LiveLookFM.BORDER_WIDTH,
				height: el.offsetHeight,// + 2*LiveLookFM.BORDER_WIDTH,
				top: pos.top,// - LiveLookFM.BORDER_WIDTH,
				left: pos.left,// - LiveLookFM.BORDER_WIDTH
				zIndex: 2000000000
			});

			__ll__.css(el.rApp, {
				position: 'absolute',
				width: LiveLookFM.BORDER_WIDTH,
				height: el.offsetHeight,// + 2*LiveLookFM.BORDER_WIDTH,
				top: pos.top,// - LiveLookFM.BORDER_WIDTH,
				left: pos.left + el.offsetWidth - LiveLookFM.BORDER_WIDTH,
				zIndex: 2000000000
			});
		}
    }

    function getDivHTML() {
        return '<div style="width:0px; height:0px; overflow: hidden; background: #' + LiveLookFM.BORDER_COLOR + ';" class="__ll_border"></div>';
    }

    function createBorder(targetInput) {
        if (targetInput.style.display == "none")
            return;

        setCSSBorders(targetInput);

		setDivBorders(targetInput);
    }

    function setCSSBorders(targetInput) {
		if(!cssUtils.hasClass(targetInput, "llBorderClass")) {
			targetInput.className += " llBorderClass";
		}
    }

    function setDivBorders(targetInput) {
    	if (window.LL_BR_Core && LL_BR_Core.ACBSupported == "none")
            return;
        var html = getDivHTML();
        targetInput.tApp = __ll__.$( html );
        targetInput.bApp = __ll__.$( html );
        targetInput.rApp = __ll__.$( html );
        targetInput.lApp = __ll__.$( html );
    }

    function fixAllPositions() {
        for (var i = 0; i < SECURE_ELEMENTS.length; i++) {
            fixElementPosition(SECURE_ELEMENTS[i]);
        }
    }

    function getSecureElements(els) {
        var arr = new Array();

        try {
            if (typeof els == "string")
                els = els.split(",");


            var elsVsClass = __ll__.$("." + LiveLookFM.SEC_FIELD_CLASS);
            if (elsVsClass != null && elsVsClass.length && elsVsClass.length > 0)
                els = els.concat(elsVsClass);


            if (els.length == 0)
                return;

            for (var i = 0; i < els.length; i++) {
                if (typeof els[i] == "string") {
                    els[i] = __ll__.$("#" + els[i]);
                }

                if (els[i] == null)
                    continue;

                arr.push(els[i]);
            }
        } catch (ex) { }

        return arr;
    }

    var _matchUrlAgainsPatterns = function (patterns, url) {
        for (var i = 0; i < patterns.length; i++) {
            if (patterns[i].match(url)) {
                return true;
            }
        }

        return false;
    };

    var _changeLocationHash = function (win, hash) {
        var isIE = __ll__.browser.msie;
        if (!isIE && typeof win.history != "undefined" && typeof win.history.pushState != "undefined") {
            var href = win.location.href;
            var ind = href.indexOf("#");
            if (ind != -1) {
                href = href.substring(0, ind);
            }
            href += "#" + hash;
            win.history.pushState(null, null, href);
        }
        else {
            win.location.hash = hash;
        }
    }

    /**
	 * Checks current frame URL agains pre-configured URL patterns and add or remove hash to the top frame URL.
	 * Note, this logic will work only when current page is included into the frame and has the same domain with top frame.
	 */
    var _checkPageBlockingBasedOnFrameUrl = function () {
        if (window != window.top) {
            // Check current location
            if (urlPatterns.length > 0) {
                var url = location.href;
                var visible = _matchUrlAgainsPatterns(urlPatterns, url);
                if (visible) {
                    visible = !_matchUrlAgainsPatterns(urlPatternsExc, url);
                }

                return !visible;
            }
        }

        return false;
    };

    var _checkSecureSectionsVisibility = function () {
        if (secureSectionsToBlock.length > 0) {
            var maskThePage = false;
            for (var i = 0; i < secureSectionsToBlock.length; i++) {
                var element = secureSectionsToBlock[i];
                if (element && element.parentNode) {
                    var visible = __ll__.css(element, "visibility") != "hidden";
                    if (visible) {
                        visible = __ll__.css(element, "display") != "none";
                    }

                    maskThePage = visible;
                    if (maskThePage) {
                        break;
                    }
                }
            }

            return maskThePage;
        }

        return false;
    };

    var _checkAllMaskings = function () {
        if (LiveLookFM.BLOCKING_HASH.length > 0) {
            var maskThePage = false;
            if (pageBlockingSupported) {
                maskThePage = _checkPageBlockingBasedOnFrameUrl();
            }

            if (!maskThePage && sectionBlockingSupported) {
                maskThePage = _checkSecureSectionsVisibility()
            }

            try {
                if (maskThePage) {
                    if (top.location.hash != "#" + LiveLookFM.BLOCKING_HASH) {
                        _changeLocationHash(window.top, LiveLookFM.BLOCKING_HASH);
                    }
                }
                else if (top.location.hash == "#" + LiveLookFM.BLOCKING_HASH) {
                    _changeLocationHash(window.top, "");
                }
            } catch (ex) { }
        }

        if (SECURE_ELEMENTS.length > 0) {
            fixAllPositions();
        }
    };

    return {
        drawCssBorders: function() {
            var secEls = getSecureElements(window.LL_Deployment && LL_Deployment.FM ? LL_Deployment.FM.elementsArray : "");
            for (var i = 0; i < secEls.length; i++) {
                setCSSBorders(secEls[i]);
            }
        },
        fastApplyCSSBorders: function () {

            if (window.LL_BR_Core && LL_BR_Core.ACBSupported == "none") {
                // don't draw borders for ICB only deployments
            }
            else {
				LiveLookFM.cssElement = cssUtils.createCSSClass(LiveLookFM.SEC_FIELD_CLASS);
            }
        },

        BORDER_WIDTH: window.LL_Deployment && LL_Deployment.FM ? LL_Deployment.FM.borderWidth : 2,
        BORDER_COLOR: "ffffff",
        TEXT_COLOR: "000000",
        fieldMask: function (els) {
            SECURE_ELEMENTS = getSecureElements(els);

            if (typeof LiveLookFM.SEC_SECTION_CLASS != "undefined" && LiveLookFM.SEC_SECTION_CLASS.length > 0) {
                secureSectionsToBlock = __ll__.$("." + LiveLookFM.SEC_SECTION_CLASS);
                sectionBlockingSupported = secureSectionsToBlock.length > 0;
            }

            var ICB_only = window.LL_BR_Core && LL_BR_Core.ACBSupported == "none";
            if (SECURE_ELEMENTS.length == 0 && !ICB_only) {
                if (pageBlockingSupported || sectionBlockingSupported) {
                    if (FIELD_POS_FIX_TIMER == 0) {
                        FIELD_POS_FIX_TIMER = setInterval(_checkAllMaskings, POS_FIX_INTERVAL);
                    }
                }
                else {
                    // check masking only once to remove blockin hash from URL if there is no any secure section in the page.
                    // this code will work for dynamically removed sections. 
                    _checkAllMaskings();
                }

                return;
            }

            if (window.LL_Deployment && LL_Deployment.FM && LL_Deployment.FM.isLookupByClassEnabled) {
                //iterate through all elements to remove borders if they exist.
                var borderElements = __ll__.$(".__ll_border");
                if (borderElements && borderElements != null && borderElements.length && borderElements.length > 0) {
                    for (var i = 0; i < borderElements.length; i++) {
                        //remove borders
                        __ll__.remove(borderElements[i]);
                    }
                }
            }

            for (var i = 0; i < SECURE_ELEMENTS.length; i++) {
                createBorder(SECURE_ELEMENTS[i]);
            }

            var ICB_only = window.LL_BR_Core && LL_BR_Core.ACBSupported == "none";
            if (SECURE_ELEMENTS.length > 0 && FIELD_POS_FIX_TIMER == 0 && !ICB_only) {
                FIELD_POS_FIX_TIMER = setInterval(_checkAllMaskings, POS_FIX_INTERVAL);
            }
        },

        init: function () {
            LiveLookFM.fastApplyCSSBorders();

            __ll__.listen("ready", window, function () {
                LiveLookFM.fieldMask(window.LL_Deployment && LL_Deployment.FM ? LL_Deployment.FM.elementsArray : "");
            });


            if (window != window.top) {
                var ltbUrls = window.LL_Deployment && LL_Deployment.FM ? LL_Deployment.FM.ltbUrls : "";
                var ltbUrlsExc = window.LL_Deployment && LL_Deployment.FM ? LL_Deployment.FM.ltbUrlsExc : "";

                if (ltbUrls && ltbUrls.length > 0) {
                    var ltbUrlsArray = ltbUrls.split(",");

                    for (var i = 0; i < ltbUrlsArray.length; i++) {
                        urlPatterns[i] = new __ll__.UrlPattern(ltbUrlsArray[i]);
                    }

                    if (ltbUrlsExc && ltbUrlsExc.length > 0) {
                        var ltbUrlsExcArray = ltbUrlsExc.split(",");
                        for (var i = 0; i < ltbUrlsExcArray.length; i++) {
                            urlPatternsExc[i] = new __ll__.UrlPattern(ltbUrlsExcArray[i]);
                        }
                    }

                    pageBlockingSupported = true;
                    _checkPageBlockingBasedOnFrameUrl();
                }
            }
        }
    }
}();

LiveLookFM.BORDER_COLOR = "";
LiveLookFM.TEXT_COLOR = "";
LiveLookFM.SEC_FIELD_CLASS = "LLBlocked";
LiveLookFM.BLOCKING_HASH = "llblock";
LiveLookFM.SEC_SECTION_CLASS = "LLPageBlocked";

LiveLookFM.init();
