// OLB - common JS

var olb = olb || { };

var messageSent=false;

$(document).ready(function(){
	// Pre-load the spinner image
	preloadSpinner();
	  
	// JS hack for JS errors in IE from console.log()
	if (typeof console == "undefined") {
	    this.console = {log: function() {}};
	}

	// ACCESSIBLE ONCHANGE SELECT MENUS
	$("select.refreshes").each(function(){
	
	var clicked = false,
		changed = false;
	
	//capture the onChange attribute as a reference of the window object so it can be called as function later.
	var onchange = window[$(this).attr("onChange")];	

	//handle events
	//mousedown = registers that the select has been clicked, shows no tooltip
	//focus = if the select has not been clicked, create and show a tooltip
	//change = do nothing but cache that the change has occured
	// blur execute the function captured from the onChnge attribute
	$(this).bind({
		mousedown: function () {
			//track when this select has been clicked
			clicked = true;
		},
		focus: function() {

			// if select menu has not been clicked beforehand, show the tooltip
			if (!clicked ) {
				$(this).olbTooltip({
			    	'orientation': 'vertical',
			    	'alignment' : 'center',
			    	'content': "This page will refresh when you select a new option and hit the Tab key.",
			    	'className' : "onchg_tip"
				});
				$(this).olbTooltip('show');
			}
		},
		change: function () {
			changed = true;
			
			if(clicked){
				onchange();
			}
		},
		blur: function () {
			
			//$(this).olbTooltip('destroy');
			// set clicked back to false in case user clicks and then tabs to the element
				clicked = false;
			
			if(changed && !clicked){
				onchange();
				changed = false;
				clicked = false;
			}
		}
		//end .bind()
		});
	//end .each()
	});
	
	
	
	// FORMAT PHONE, SSN, ZIP
	$('body').on('keydown', '.tel_input,.ssn_input,.zip_input',function(e){
		// INPUT ONLY ACCEPTS NUMBERS
		var key = e.keyCode;
		var val = $(this).val();
		var length = val.length;
		if (	
			key == 46 //DELETE 
			|| key == 8 // OR BACKSPACE
			|| key == 9 // OR TAB
			|| key == 27 // OR ESC
			|| key == 13 // OR ENTER
			|| (key == 65 && e.ctrlKey === true) // OR CNTRL + ANY LETTER
			|| (key == 91 && key == 65) // OR WINDOWS KEY + A
			|| (key >= 35 && key <= 40) ) // OR END, HOME, ARROWS
		{ 
       		return;
        }
        else {
        	if (e.shiftKey || (key < 48 || key > 57) && (key < 96 || key > 105 )) { // JUST NUMBERS
	        	e.preventDefault(); 
        	}
        }
        
        if ( key !== 8 ){ // IF IT'S NOT BACKSPACE, FORMAT SOME INPUT
        	if ( $(this).hasClass('tel_input') ) {
        		if (length === 3) $(this).val(val + '-');
				if (length === 7) $(this).val(val + '-');
				$(this).attr('maxlength',12);
        	}
        	else if ( $(this).hasClass('ssn_input') ) {
        		if (length === 3) $(this).val(val + '-');
				if (length === 6) $(this).val(val + '-');
				$(this).attr('maxlength',11);
        	}
        	else if ( $(this).hasClass('zip_input') ) {
        		if (length === 5) $(this).val(val + '-');
        		$(this).attr('maxlength',10);
        	}
        }
	});


	//clear labels for any text fields that have values.
	$("input[type='text'], input[type='password'], input[type='tel']").each(function(){
		if( $(this).val() != ""){
			$(this).siblings("label").hide();
		}
	});
	

	//Code to invoke the show/hide grid links.
    $("a.link-grid").click(function(){
        $("div.container").toggleClass('show-grid');                         
    });

    //Code to invoke the show/hide toggle grid text.
    $("a.link-grid").toggle(function (){
    	$(this).text("Hide Grid")
    		}, 
    		function(){
        $(this).text("Show Grid")
    		});

	$(".account-summary-table tr:last-child").css('display','none');
	
	// saving the original version of the title, in case we need to "update"
	// the page title without reloading the page (i.e. in the case where we
	// are dynamically changing the .page-title header via javascript.)
	olb.originalTitle = $("head > title").html();
	try { updatePageTitle(); } catch (e) { }
	
    //Code to invoke when the Unread Count on the Message Center Link needs refresh.
	$(document).on("updateCount", "#secure-message-link", function() {
	    // ajax call to update the unread message count  
	    $.ajax({
	         type: 'POST',
	         async: true,
	         url: env.contextPath + '/unreadMessageCount',
	         success: function(data) {
                 //replace the div with the response
                 $("#secure-message-link").replaceWith(data);
	         }
	    });
	    return false;
	});
	
	
	/**
	 * This function formats the currency fields which has class="currency" while keypress, keyup and focusing out
	 */
	
				 $(".currency-format").bind('keypress',function(event) {

										if (event.keyCode == 9)
											return true;
										var regex = new RegExp("^[0-9.,\b]+$");
										var key = String
												.fromCharCode(!event.charCode ? event.which
														: event.charCode);
										if (!regex.test(key)) {
											event.preventDefault();
											return false;
										}

										var val = $(this).val();
										var tempArray = new Array();
										var tempArray = val.split(".");
										if (key == "." && tempArray.length == 2){
											event.preventDefault();
											return false;
										}

									});

					$(".currency-format").bind('keyup',function(event) {

										if (event.keyCode == 9)
											return true;

										var regex = new RegExp("^[0-9.,\b]+$");

										var val = $(this).val();
										var tempArray = new Array();
										var tempArray = val.split(".");

										if (tempArray.length > 2) {
											$(this).val(
													val.substring(0,
															val.length - 1));
											event.preventDefault();
											return false;
										}

										if (tempArray.length == 2) {
											var afterDecimals = tempArray[1];
											if (afterDecimals.length > 2) {
												$(this)
														.val(
																tempArray[0]
																		+ '.'
																		+ afterDecimals
																				.substring(
																						0,
																						2));
											}
										}

									});
					
					

					$(".currency-format").blur(function() {
						
								if ($(this).val() != '') {
									$(this).val(
											formatCurrency($(this)
													.val()));
								}
							});
					
					$(".currency-format").keyup(function(event) {

								if (event.keyCode == 13) {

									if ($(this).val() != '') {
										$(this).val(
												formatCurrency($(this)
														.val()));
									}

								}
							});

					function formatCurrency(num) {
						num = num.toString().replace(/\$|\,/g, '');
						if (isNaN(num))
							num = "0";
						sign = (num == (num = Math.abs(num)));
						num = Math.floor(num * 100 + 0.50000000001);
						cents = num % 100;
						num = Math.floor(num / 100).toString();
						if (cents < 10)
							cents = "0" + cents;
						for ( var i = 0; i < Math
								.floor((num.length - (1 + i)) / 3); i++)
							num = num.substring(0, num.length - (4 * i + 3))
									+ ','
									+ num.substring(num.length - (4 * i + 3));
						return (((sign) ? '' : '-') + num + '.' + cents);
					}
	
});

function updatePageTitle() {
    // Update the page title based on the the first heading
    // This bit of ridiculousness grabs just the text node - not the text of any children
    // within the page title (you may have a button or something else..)
    var title = $("body section.content-left .page-title:first").clone().children().remove().end().text();
    if (title) {
        // Note: IE does not let you use html() or text() on the title element
        document.title = olb.originalTitle + " | " + title;
    }
}


function womAdd(func) {
	$(document).ready(func);
}

var js = {
	    pop: function (link, target, urchin, features) { 
	        var defaults = { width : '640', height : '480', menubar : 'no', locationbar : 'no', resizable: 'yes', scrollbars : 'yes', statusbar : 'yes', toolbar: 'no', directories: 'no' };
	        if (features) {
	            var trimmed = features.replace(/\s/g, '');
	            var specs = trimmed.split(',') ;
	            for (i = 0; i < specs.length; i++) {
	                var s = specs[i].split('=');
	                switch (s[0]) {
	                    case 'width':
	                        defaults.width = s[1];
	                        break;
	                    case 'height':
	                        defaults.height = s[1];
	                        break;
	                    case 'menubar':
	                        defaults.menubar = s[1];
	                        break;
	                    case 'location':
	                        defaults.locationbar = s[1];
	                        break;
	                    case 'resizable':
	                        defaults.resizable = s[1];
	                        break;
	                    case 'scrollbars':
	                        defaults.scrollbars = s[1];
	                        break;
	                    case 'status':
	                        defaults.statusbar = s[1];
	                        break;
	                    case 'toolbar':
	                        defaults.toolbar = s[1];
	                        break;
	                    case 'directories':
	                        defaults.directories = s[1];
	                        break;
	                    default:
	                        break;
	                }
	            }
	        }

	        if (target === '') {
	            target = '_new';
	        }

	        window.open(link, target, "width=" + defaults.width + ",height=" + defaults.height + ",menubar=" + defaults.menubar + ",location=" + defaults.locationbar + ",resizable=" + defaults.resizable + ",scrollbars=" + defaults.scrollbars + ",status=" + defaults.statusbar + ",toolbar=" + defaults.toolbar + ",directories=" + defaults.directories); 

	        return false;
	    }

};

function submitForm(formName) {
	document.forms[formName].submit();
}

// Can be called when you are dynamically adding new form elements to a page
function applyFormalize() {
    // Make formalize apply to the new elements in the dialog
    try { FORMALIZE.go(); } catch (e) { }   
}


/**
 * jQuery plugin for a custom Modal Dialog in OLBR.
 * To instantiate: jQuery("your-selector").modal(settings);
 * "your-selector" should be a jQuery selector that gives you the content of your modal dialog.
 * settings should be a Javascript object of settings.
 * 
 * To display (fade in & apply the blackout) the modal dialog, call jQuery("your-selector").modal("open");
 * To close (fade out & remove the blackout), call jQuery("your-selector").modal("close");
 * 
 * This plugin applies the style guide defaults, but several overrides are supported.
 * 
 * The settings values are:
 *     'closeable' (boolean, whether or not the user can manually close the dialog - defaults to true)
 *     'closeOnEscape' : (boolean, whether the escape key closes the dialog if the dialog is closeable - defaults to true)
 *     'height' : (number, defaults to 55% of the available window height)
 *     'width' : (number, defaults to 864)
 *     'title' : (string, if specified, it will display a "heading" with this title in the dialog.  Defaults to the title attribute on the originating element if available.)
 *     'buttons': (array of "button" objects, if specified, will render a footer area with those buttons)
 *     'beforeOpen': (function, will be run before the dialog is opened)
 *     'beforeShow': (function, will be run before the dialog is shown [i.e. before the fade-in])
 *     'beforeClose': (function, will be run before the dialog is closed)
 *     'afterOpen': (function, will be run after the dialog is opened)
 *     'afterClose': (function, will be run after the dialog is closed [i.e. after the fade-out])
 * 
 * A button object can have the following attributes:
 *     'label' (string, required, the text of the button)
 *     'id' (string, required, the element id to put on the button)
 *     'className' (string, any css classes to apply to the button)
 *     'link' (string, causes the button to be rendered as a button-looking anchor, with this as the link)
 *     'onClick : (function to invoke on the "click" event of the button)
 * 
 */
(function( $ ) {
    
    // counter to be incremented as we generate new modals on the page
    var idCounter = 0;
    
    var methods = {
        
        init : function(options) {
            var height = $(window).height() * 0.55;
            return this.each(function() {
                var $this = $(this);
                var settings = $.extend( {
                    'closeable' : true,
                    'closeOnEscape' : true,
                    'height' : height,
                    'width' : 864,
                    'containerSelector' : 'body',
                    title : $this.attr("title"),
                    buttons: [ ]
                }, options);
                var id = "modal-" + (idCounter++);
              
                $this.data("modal", {
                    target : $this,
                    'settings' : settings,
                    'id' : id
                });
            });
            
        },
        destroy : function() {
            this.each(function() {
                var $this = $(this), data = $this.data('modal');
                // put the content nodes back in the original target
                var $modal = $("#"+data.id);  
                
                $this.append($modal.find(".content").children());
                // remove the button click events if there
                $modal.find(".header a").unbind("click");
                $modal.find(".footer button").unbind("click");
                 // remove the modal from the DOM
                $modal.remove();
                $this.removeData('modal');
            });
            $(".blackout").remove();
            return this;
        },
        open : function(event) {
        	var $this = $(this), data = $this.data('modal');
            methods._beforeOpen.apply(this, [event]);
            // add or show blackout
            methods._addOrShowBlackout.apply(this);
            // add or show the modal itself
            var $modal = data.modal;
            if (!$modal) {
                $modal = methods._createModal.apply(this);
                data.modal = $modal;
            }
            methods._centerModal($modal);
            methods._closeOthers.apply(this);
            methods._beforeShow.apply(this, [event]);
            // XXX Workaround for chrome scrollbars flashing on fades in windows xp
            // See http://code.google.com/p/chromium/issues/detail?id=24524
            // This was supposedly fixed, but the "fix" doesn't seem to work.
            // The workaround is: hide the scrollbar until after the fade.
            $modal.find(".content").css("overflow-y", "hidden");
            var that = this;
            var fadeInDelay = ($.browser.msie)? 0:200;
            $modal.fadeIn(fadeInDelay, function() {
                $(this).focus();
                $(this).find(".content").css("overflow-y", "auto");
                methods._afterOpen.apply(that, [event]);
            });
            
            //fix navigation in IE
            if ( jQuery(window).scrollTop() > 90 ) {
            	jQuery('nav').addClass('fixed');
            	jQuery('header').css('margin-bottom','45px');
            }
            else {
            	jQuery('nav').removeClass('fixed');
            	jQuery('header').css('margin-bottom','0px');
            }
        },
        close : function(event) {
            var $this = $(this), data = $this.data('modal');
            methods._beforeClose.apply(this, [event]);
            // hide the modal
            var $modal = data.modal;
            if ($modal) {
                $modal.find(".content").css("overflow-y", "hidden");
                var that = this;
                var fadeInDelay = ($.browser.msie)? 0: 200;
                $modal.fadeOut(fadeInDelay, function() {
                    // hide blackout
                	$("html,body").css("overflow","visible");
                    $("body .blackout").hide();
                    methods._afterClose.apply(that, [event]);
                });
            }
            
            //fix navigation in IE
            if ( jQuery(window).scrollTop() > 90 ) {
            	jQuery('nav').addClass('fixed');
            	jQuery('header').css('margin-bottom','45px');
            }
            else {
            	jQuery('nav').removeClass('fixed');
            	jQuery('header').css('margin-bottom','0px');
            }
        },        
        _closeOthers : function() {
            $(".modal").hide();
        },
        _beforeClose : function(event) {
            var fn = $(this).data('modal').settings.beforeClose;
            if (fn && typeof(fn) == "function") {
                fn.apply(this, [event]);
            }
        },
        _afterClose : function(event) {
            var fn = $(this).data('modal').settings.afterClose;
            if (fn && typeof(fn) == "function") {
                fn.apply(this, [event]);
            }
        },
        _beforeShow : function(event) {
            var fn = $(this).data('modal').settings.beforeShow;
            if (fn && typeof(fn) == "function") {
                fn.apply(this, [event]);
            }
        },
        _beforeOpen : function(event) {
            var fn = $(this).data('modal').settings.beforeOpen;
            if (fn && typeof(fn) == "function") {
                fn.apply(this, [event]);
            }
        },
        _afterOpen : function(event) {
            var fn = $(this).data('modal').settings.afterOpen;
            if (fn && typeof(fn) == "function") {
                fn.apply(this, [event]);
            }
        },
        _addOrShowBlackout : function() {
            var data = $(this).data('modal');
            var $blackout = $("body .blackout");
            if (!$blackout.length) {
                $blackout = $("<div>").addClass("blackout").css("display", "none").appendTo(data.settings.containerSelector);
            }                       
            $("body").css("overflow","hidden");
            $blackout.show();
        },
        _centerModal : function($modal) {
            // Calculate the width & height, then figure out the adjustments given the window size
            var left = ( $(window).width()  / 2 ) - ( $modal.outerWidth()  / 2 );
            var top  = ( $(window).height() / 2 ) - ( $modal.outerHeight() / 2 );
            $modal.css( {"left": left, "top": top} );
        },
        _createModal : function() {
            var data = $(this).data('modal');
            var that = this;
            var $modal = $("<div>")
                .attr({
                    'id'        : data.id,
                    "role"      : "dialog",
                    "aria-live" : "polite",
                    "tabIndex"  : -1        // Allows "focus" on modal, so we can close on focus+escape 
                })
                .css({
                    "display"   : "none",
                    visibility : "visible"  // with display: none & visibility: visible, we can calculate offsets
                })
                .addClass("modal");
            var height = data.settings.height;
            var $header, $footer, content = null;
            
            // Add title if available
            if (data.settings.title) {
                height -= 40;
                var titleId = "title-" + data.id;
                $header = $("<div>").attr('id', titleId).addClass('header').html(data.settings.title);
                if (data.settings.closeable) {
                    $("<a>")
                        .addClass('close')
                        .attr('href', '#')
                        .html("Close")
                        .click(function( event ) {
                            event.preventDefault();
                            methods.close.apply(that, [event]);
                        })
                        .appendTo($header);
                }
                $modal.attr('aria-labelledby', titleId);
            }
            
            // Add footer if we have buttons to show
            if (data.settings.buttons && $.isArray(data.settings.buttons) && data.settings.buttons.length > 0) {
                height -=40;
                $footer = $("<div>").addClass("footer");
                // button: { label: '', id: '', className: "", onClick : fn, link: '' } (onClick & link are optional)
                for (var i=0; i<data.settings.buttons.length; i++) {
                    var button = data.settings.buttons[i];
                    var $button;
                    if (button.link) {
                        $button = $("<a>").addClass("button").attr("href", button.link);
                    }
                    else {
                        $button = $("<button>");
                        $button.click(button.onClick);
                    }
                    $button.addClass(button.className).attr("id", button.id).html(button.label).appendTo($footer);
                }
            }
            
            // Build the content area
            $content = $("<div>")
                .addClass("content")
                .css({    
                    "width"      : data.settings.width + "px",
                    "max-height" : height + "px"
                })
               .append(data.target.contents());
        
            // Put everything together
            $modal.append($header).append($content).append($footer);
        
            
            if (data.settings.closeOnEscape) {
                $modal.keydown(function( event ) {
                	if (!event.isDefaultPrevented() && event.keyCode === 27 ) {
                        methods.close.apply(that, [event]);
                        event.preventDefault();
                    }
                    
                    if ( event.keyCode === 9 ) {
                    	
                    	var tabbables = $modal.find(":tabbable"),
                        first = tabbables.filter(":first"),
                        last  = tabbables.filter(":last");
                    	
                    	if ( ( event.target === last[0] || event.target === $modal[0] ) && !event.shiftKey ) {
	                        first.focus( 1 );
	                        event.preventDefault();
	                    } else if ( ( event.target === first[0] || event.target === $modal[0] ) && event.shiftKey ) {
	                        last.focus( 1 );
	                        event.preventDefault();
	                    }
                    }
                    
 				});                    
					 
                	$(":tabbable:first").focus(function() { 
                        $(".modal:visible:last :tabbable:first").focus();
                     });
              }  
                $modal.appendTo(data.settings.containerSelector);
	            return $modal;
          }
      
        
    };
    
    $.fn.modal = function ( method ) {
        if ( methods[method] ) {
            return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
        } else if ( typeof method === 'object' || ! method ) {
            return methods.init.apply( this, arguments );
        } else {
            $.error( 'Method ' +  method + ' does not exist on jQuery.modal' );
        } 
    };
    
})( jQuery );

/**
 * OLBR jquery plugin for showing & hiding a tooltip.
 * 
 * Works similarly to the jQuery-ui tooltip, but handles custom modifications to follow the OLB style guide.
 * This supports showing a tooltip following our alignment guide - above or to the side (right)
 * This plugin gives us more fine-grained control over the fade in/out, positioning, and ARIA support
 * than the official jquery-ui tooltip plugin.
 * 
 * Plugin Options:
 *     orientation: 'horizontal' or 'vertical' (defaults to 'horizontal')
 *     alignment: 'right', 'center', or 'left' for horizontal; 'top', 'center', or 'bottom' for vertical.
 *                (defaults to 'left', unless the target is float:right, in which case it defaults to 'right')
 *     content: html or function to return html (defaults to using the content in the target's "title" attribute)
 *     className: any additional classes to put on the tooltip that is rendered                
 */
(function( $ ) {

    // counter to be incremented as we generate new tooltip ids on the page
    var idCounter = 0;
    
    // container of all the targets that have tooltips associated
    var targets = [ ];
    
    var methods = {

        /**
         * Constructor
         * @param options Tooltip Settings to use
         */
        init : function(options) {
            
            return this.each(function() {
                
                var $this = $(this);
                
                // Save the content from the title attribute, but remove it
                // as well so the browser does not try to render it natively
                var title = $this.attr("title");
                $this.removeAttr("title");
                
                var settings = $.extend( {
                    'orientation' : 'horizontal',
                    'alignment' : $this.css("float") == "right" ? "right" : "left",
                    'content' : title,
                    'className' : ''
                }, options);
                
                $this.data("olbTooltip", {
                    target : $this,
                    'settings' : settings,
                    id : "tooltip-" + idCounter++,
                    'title' : title
                });
                
                targets.push($this);
                
                $this.bind('focus.olbTooltip mouseenter.olbTooltip', function() {
                    methods.show.apply(this);
                });
                
                $this.bind('focusout.olbTooltip mouseleave.olbTooltip', function() {
                    methods.hide.apply(this);
                });
                
            });
            
        },
        
        /**
         * Mechanism for destroying this plugin.  This will result in the tooltip no longer
         * being bound to the show/hide methods.
         */
        destroy : function() {
            return this.each(function(){
                var $this = $(this), data = $this.data('olbTooltip');
                var tooltip = data && data.tooltip;
                if (tooltip) {
                    tooltip.remove();
                }
                var title = data && data.title;
                if (title) {
                    data.target.attr('title', title);
                }
                $this.unbind('.olbTooltip');
                $this.removeData('olbTooltip');
                targets.length = 0;
            });
        },
        
        /**
         * Show the tooltip, creating the tooltip element in the DOM if it is not already there.
         */
        show : function() {
            var $this = $(this);
            
            // Hide any existing tooltips still be diplayed, in case the fade-out
            // of existing ones is still animating
            $(".ui-tooltip").hide();
            // Remove all the aria-describedbys
            methods._removeAllDescribedBys.apply(this);
            
            var tooltip = $this.data('olbTooltip').tooltip;
            if (!tooltip) {
                tooltip = methods._create.apply(this);
                $this.data('olbTooltip').tooltip = tooltip;
            }
            // Now that the tooltip is created and its size calculated, we can
            // figure out exactly where to position it and make it visible
            // We need to re-position this every time, in case the page
            // layout may have changed due to dynamic showing/hiding/manipulation
            // of elements (including the tooltip target)
            tooltip.css( methods._getPositionCss.apply(this, [tooltip]) );
            
            methods._addDescribedBy.apply(this);
            
            tooltip.fadeIn(200);
        },
        
        /**
         * Hide the tooltip
         */
        hide : function() {
            var $this = $(this), data = $this.data('olbTooltip');
            var tooltip = data.tooltip;
            var target = data.target;
            tooltip.fadeOut(200);
            methods._removeDescribedBy.apply(this);
        },
        
        /**
         * @returns the actual tooltip DOM element to be rendered on the page, including styles,
         * but hidden
         */
        _create : function() {
            var settings = $(this).data('olbTooltip').settings;
            
            // Create the tooltip - it needs to be a block, but visibility hidden, so
            // we can calculate the real display size, to position it properly
            // The tooltip div will have two child divs: the content & the arrow
  			var arrow = $("<div>")
                .addClass("arrow")
                .addClass(settings.alignment);
            var content = $("<div>", { 
                html: settings.content
            }).addClass("tooltip-content");
            
            var tooltip = $("<div>")
                .attr({
                    id: $(this).data('olbTooltip').id,
                    role: "tooltip",
                    "aria-live": "polite"
                })
                .append(content)
                .append(arrow)
                .addClass("tooltip").addClass(settings.className)
                .css({
                    position: "absolute",
                    display: "block",
                    visibility: "hidden"
                })
                .appendTo("body");
 			
 			var horOrientation = methods._isNavOverLaping($(this),tooltip) ?'up':'down'; 
			arrow .addClass(settings.orientation == 'horizontal' ? horOrientation : 'v-left')  ;          
            return tooltip;
        },
        
        /**
         * Calculates the exact positioning for the tooltip
         * 
         * @param tooltip DOM element representing the tooltip to be shown
         * 
         * @returns Object containing the CSS attributes for positioning & visibility
         */
        _getPositionCss : function(tooltip) {
            var target = $(this).data('olbTooltip').target;
            var settings = $(this).data('olbTooltip').settings;
            var tooltip = $(tooltip);
            
            var top, left;

            if (settings.orientation == 'horizontal') {
                // 5px offset is from style guide
              top =methods._isNavOverLaping(target,tooltip) ?  (target.offset().top + target.outerHeight()+5):(target.offset().top - tooltip.outerHeight() - 5);
                  if (settings.alignment == 'left') {
                    left = target.offset().left - 20; //used to be 14
                }
                else if (settings.alignment == 'center') {
                    left = target.offset().left  + target.outerWidth() / 2 - tooltip.outerWidth() / 2;
                }
                else {
                    var right = target.offset().left + target.outerWidth()/2; //used to be target.outerWidth not target.outerWidth/2;
                    left = right - tooltip.outerWidth() + 20; //used to be 14
                    //diving the width of the target by 2 and subtracting 20 centers the tooltip arrow on the target
                    //even if the tooltip itself is right aligned.
                }
            }
        
            else {
                // must be vertical
                var right = target.offset().left + tooltip.outerWidth();
                left = right;
                if (settings.alignment == 'top') {
                    top = target.offset().top - 14;
                }
                else if (settings.alignment == 'center') {
                    top = target.offset().top + target.outerHeight() / 2 - tooltip.outerHeight() / 2 - 2;
                }
                else if (settings.alignment == 'bottom') {
                    var bottom = target.offset().top + target.outerHeight();
                    top = bottom - tooltip.outerHeight() + 14;
                }
            }
            
            return {
                visibility : "visible",
                display : "none",
                "left" : left + "px",
                "top" : top + "px"
            };
            
        },
       

		/**
         * Check whether the tooltip overlaps with the navigation.
         */
       _isNavOverLaping:function(target,tooltip){
        	if (!$('nav').length) {
        		return false;
        	};
	        return tooltip.outerHeight()	>(target.offset().top - $('nav').offset().top-$('nav').outerHeight())	;
        },
        /**
         * Associates the tooltip target with the tooltip via the aria-describedby attribute
         */
        _addDescribedBy : function() {
            var target = $(this).data('olbTooltip').target;
            var tooltipId = $(this).data('olbTooltip').id;
            target.attr("aria-describedby", tooltipId);
        },
        
        /**
         * Disassociates the tooltip target with the tooltip
         */
        _removeDescribedBy : function() {
            var target = $(this).data('olbTooltip').target;
            target.removeAttr("aria-describedby");
        },
        
        /**
         * Removes all aria-describedby attributes from all targets of the tooltip
         */
        _removeAllDescribedBys : function() {
            for (var target in targets) {
                $(target).removeAttr("aria-describedby");
            }
        }
        
    };
    
    $.fn.olbTooltip = function ( method ) {
        if ( methods[method] ) {
            return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
        } else if ( typeof method === 'object' || ! method ) {
            return methods.init.apply( this, arguments );
        } else {
            $.error( 'Method ' +  method + ' does not exist on jQuery.olbTooltip' );
        } 
    };
    
})( jQuery );

/**
 * OLBR jquery plugin for limiting an input field to numeric keys entry.
 * Usage: jQuery("input-element-name").forceNumericChar();      
 * 
 *  Args: 
 *     numbersOnlyFlag : If true, commasa and decimals will not be allowed
 *     allowNegativeFlag ; if true, negative sign can be used
 * 
 *  Only allows the following keys:
 *   1 2 3 4 5 6 7 8 9 0 . , [backspace] [tab] [delete]
 */
(function( $ ) {
	$.fn.forceNumericChar =
	    function(numbersOnlyFlag, allowNegativeFlag) {
	        return this.each(function() {
	            $(this).keydown(function(event) {
	                var key = event.charCode || event.keyCode || 0;
	                return ((numbersOnlyFlag === false && key == 190 && !event.shiftKey) ||    // keycode for a period
	                   (numbersOnlyFlag === false && key == 110 && !event.shiftKey) ||    // keycode for a decimal, yes decimal and period are diff codes
	                   (numbersOnlyFlag === false && key == 188 && !event.shiftKey) ||    // keycode for a comma
	                   key == 8 || // backspace
	                   key == 9 || // tab
	                   key == 46 || // delete
	                   (key >= 35 && key <= 40) || // keycode for End, Home, Left, Up, Right and Down arrow
	                   (true === allowNegativeFlag && key == 189) || (true === allowNegativeFlag && key == 109) || // minus/dash
	                   (key >= 48 && key <= 57 && !event.shiftKey) || // numbers
	                   (key >= 96 && key <= 105) || // keycode for Numpad numbers
	                   (numbersOnlyFlag === false && key == 110 && !event.shiftKey)); // keycode for Numpad period
	            })
	        })
	    };
})( jQuery );

// Overrides of jQuery-ui datepicker internal functions
(function( $ ) {
    $.extend($.datepicker, {
        // Overriding checkOffset so that we can control exactly where the datepicker is displayed
        _checkOffset: function(inst, offset, isFixed) {
            var $input = $(inst.input);
            var $dp = $(inst.dpDiv);
            offset.top = $input.offset().top + ($input.height() / 2) - ($dp.height() / 2 - $input.height() / 2);
            offset.left = $input.offset().left + $input.outerWidth() + 15;
            return offset;
        },
        // Overriding the jquery-ui datepicker widget keyboard controls because they do not conform
        // to the "standard" key bindings found at http://dev.aol.com/dhtml_style_guid/#datepicker
        // If the datepicker source changes drastically, there is a good chance this will break
        // given its heavy use & dependence on the "private" internal functions of the datepicker.
        _doKeyDown: function(event) {
            var inst = $.datepicker._getInst(event.target);
            var handled = true;
            var isRTL = inst.dpDiv.is('.ui-datepicker-rtl');
            inst._keyEvent = true;
            if ($.datepicker._datepickerShowing) {
                switch (event.keyCode) {
                    // Tabbing in & out
                    case 9: $.datepicker._hideDatepicker();
                            handled = false;
                            break; // hide on tab out
                    // Arrow Up: goes to same day of the week in previous week.
                    case 38:
                            $.datepicker._adjustDate(event.target, -7, 'D');
                            break;
                    // Arrow Down: goes to same day of the week in next week.
                    case 40:
                            $.datepicker._adjustDate(event.target, +7, 'D');
                            break;
                    // Arrow Left: goes to previous day
                    case 37:
                            $.datepicker._adjustDate(event.target, -1, 'D');
                            break;
                    // Arrow Right: goes to next day
                    case 39:
                            $.datepicker._adjustDate(event.target, +1, 'D');
                            break;
                    // Page Up: Move to same date in previous month. 
                    // XXX Ctrl + PgUp: Move to same date in previous year. (conflicts w/ firefox)
                    case 33:
                            $.datepicker._adjustDate(event.target, -1, 'M');
                            break;
                    // Page Down: Move to same date in next month. 
                    // XXX Ctrl + PgDn: Move to same date in next year.
                    case 34:
                            $.datepicker._adjustDate(event.target, +1, 'M');
                            break;
                    // Space: toggle (select or deselect date)
                    case 32:
                            var calDate = $.datepicker._formatDate(inst);
                            var fieldDate = inst.input.val();
                            if (calDate == fieldDate) {
                                inst.input.val("");
                            }
                            else {
                                inst.input.val(calDate);
                            }
                            $.datepicker._updateAlternate(inst);
                            break;
                    // Home: Move to first day of current month
                    case 36:
                            var days = inst.selectedDay - 1;
                            $.datepicker._adjustDate(event.target, -days, 'D');
                            break;                    
                    // End: Move to last day of current month
                    case 35:
                            var days = $.datepicker._getDaysInMonth(inst.selectedYear, inst.selectedMonth) 
                                - inst.selectedDay;
                            $.datepicker._adjustDate(event.target, days, 'D');
                            break;
                    // Enter: set the date & close the datepicker
                    case 13:
                            var sel = $('td.' + $.datepicker._dayOverClass + ':not(.' + $.datepicker._currentClass + ')', inst.dpDiv);
                            if (sel[0]) {
                                $.datepicker._selectDay(event.target, inst.selectedMonth, inst.selectedYear, sel[0]);
                            }
                            var onSelect = $.datepicker._get(inst, 'onSelect');
                            if (onSelect) {
                                var dateStr = $.datepicker._formatDate(inst);
                                // trigger custom callback
                                onSelect.apply((inst.input ? inst.input[0] : null), [dateStr, inst]);
                            }
                            else {
                                $.datepicker._hideDatepicker();
                            }
                            break;
                    // Escape: closes datepicker
                    case 27:
                            $.datepicker._hideDatepicker();
                            break;
                    default: handled = false;
                }
            }
            else {
                handled = false;
            }
            if (handled) {
                event.preventDefault();
                event.stopPropagation();
            }
        }
    });
})( jQuery );

/**
 * jQuery Plugin for calendar display.
 * 
 * This actually wraps the jQuery-ui datepicker plugin with some common settings.
 * 
 * To initialize, call
 * $("your-selector").calendar(settings)
 * Where "your-selector" is a jQuery selector for your date input field & settings are your settings
 */
(function($) {
    $.fn.calendar = function( options ) {
        var $this = $(this), $that = $this;
        var settings = $.extend( {
            dayNamesMin: ['SUN', 'MON', 'TUE', 'WED', 'THU', 'FRI', 'SAT'],
            showAnim: "fadeIn",
            duration: 200,
            dateFormat: 'mm/dd/yy',
            onSelect: function(inst) {
              $(this).next("label").hide();
              $this.trigger('change',true);
            } 
        }, options);
        $this.datepicker(settings);
        $this.siblings(".ico-cal").click(function(e) {
            $that.focus();
            e.preventDefault();
        });
        return this;
    };
})(jQuery);


/*
* This will define a library that will enfore a formatting on specifc box
* This will be used to format ALPHA, NUMERIC, & ALPHANUMERIC boxes
*/
(function($) {
    
    /*
     * Enforces ALPHA behavior on a box (textbox, textarea, label, ...)
     * I.E a-z/A-Z
     * Space and special characters can be configured with settings
    */
    $.fn.enforceFormat = function(settings){
        // This fetch the textbox,or ...
        var $box = this;
        
        // This will fetch the user setting for the box
        var enforcedSettings = getSettings(settings);
        
        // This will enforece the user setting
        enforce($box, enforcedSettings);

        return this;
    };

    /*
     * These are the object that will be used in setting configration
    */
    var SETTINGS = {
        allowRightClick : true,
        allowPaste      : true,
    }
    
    /*
     * These are default settings configurations
    */
	var DEFAULT_SETTINGS = {
		"Letter" : {
            pattern     : "[a-zA-Z]",
		},
        "AlphaNum" : {
            pattern     : "[0-9a-zA-Z]",
        },
        "Integer" : {
            pattern     : "[0-9]",
        },
        "Float" : {
            pattern     : "[0-9?.{1,}0-9]",
        }
	};
    
    /*
     * Extract the setting that is passed by the users or the default settings
     * The setting is predefined object that contains settings attribuetes that will allow to define alphabets and numeric objects and/or formats
     * I.E ALPHABET_SETTING & NUMERIC_SETTING
    */
    function getSettings(settings){
        if(typeof settings == "undefined"){
            var currentSetting = DEFAULT_SETTINGS["Letter"];
            var userSetting = {};
            $.extend(userSetting, SETTINGS, currentSetting);
            return userSetting;
        }
        else if(typeof settings === "string"){
            if(DEFAULT_SETTINGS.hasOwnProperty(settings)){
                var currentSetting = DEFAULT_SETTINGS[settings];
                var userSetting = {};
                $.extend(userSetting, SETTINGS, currentSetting);
                return userSetting;
            }
            else{
                var currentSetting = DEFAULT_SETTINGS["Letter"];
                var userSetting = {};
                $.extend(userSetting, SETTINGS, currentSetting);
                return userSetting;
            }
        }
    }
    
    /*
     * This will enforce LETTERS, NUMBERS (Integers & Floating Numbers), ALPHA NUMERIC values
    */
    function enforce($box, settings){
        $box.each(function(){
			var $currentBox = $(this);
            
            // This will bind the right click
            $currentBox.bind("contextmenu", function(e){
                if(!settings.allowRightClick)
                    e.preventDefault();
            });
            
            // Thsi will bind the copy paste
            $currentBox.bind("paste", function(e){
                if(!settings.allowPaste)
                    e.preventDefault();
                else{
                    if(e.originalEvent && e.originalEvent.clipboardData && e.originalEvent.clipboardData.getData){
                        var pastedText = "";
                        e.preventDefault();
                        pastedText = e.originalEvent.clipboardData.getData("text/plain");
                        
                        // setTimeout is necessary for handling the 'paste' event
                        setTimeout(function(){
                            $currentBox.val(cleanUp(pastedText, settings.pattern));
                        }, 0);
                    }
                    else{
                        // setTimeout is necessary for handling the 'paste' event
                        setTimeout(function(){
                            var pastedText = $currentBox.val();
                            $currentBox.val(cleanUp(pastedText, settings.pattern));
                        }, 50);
                    }
                }
			});
            
            // This will clean up the content when the box gets and loses focus
            $currentBox.bind("blur", function(e){
                $currentBox.val(cleanUp(this.value, settings.pattern));
            });
            
            // This will bind the keypress event
			$currentBox.bind("keypress", function(e){
                var pattern = settings.pattern;
                
                if(!isControlKey(e.which)){
                    var char = String.fromCharCode(e.which);
                    if(!char.match(pattern))
                        e.preventDefault();
                }
			});
		});
    }
    
    /*
     * This will clean up a copy pasted text
    */
    function cleanUp(text, pattern){
        var explodedText = text.split("");
        var i = 0;
        var suggestedText = [];
        for(i = 0; i < explodedText.length; i++){
            if(explodedText[i].match(pattern))
                suggestedText.push(explodedText[i]);
        }
        return suggestedText.join("");
    }
    
    /*
     * This will manage TAB, CTRL, SHIFT
    */
    function isControlKey(charCode) {
		if(charCode >= 32)
			return false;
		if(charCode == 10)
			return false;
		if(charCode == 13)
			return false;
		return true;
	}
})(jQuery);

/**
 *  Applies functionality to a label, so it acts as a placeholder in the input field
	<div class="s5" style="position:relative;">
		<input type="text" class="payable" name="Payable To" >
		<label for="payable" style="top:5px; left:5px;position:absolute;">Insert Text</label>
	</div>	

function setupPlaceholder() {
	// INPUT FIELD PLACEHOLDER FUN
    $('input[type="text"], input[type="password"], input[type="tel"]').focus(function(){
        $(this).siblings('label, span.placeholder').css('color','#bfbfbf');
    });
    
    $('input[type="text"], input[type="password"], input[type="tel"]').blur(function(){ 
        $(this).siblings('label, span.placeholder').css('color','#767676');
    });

    $('input[type="text"], input[type="password"], input[type="tel"]').keyup(function(){
        if ( $(this).val() == '' ) {
            $(this).siblings('label, span.placeholder').fadeIn(100);
        }
        else {
            $(this).siblings('label, span.placeholder').hide();
        }
    }); 
    // switches focus to the input field when clicked
    $('label, span.placeholder').click(function() {
        $(this).siblings('input').focus();
    });
}
*/

/**
*/

/**
 * Common function for Reply, Compose and Dispute functionlities to post the user entered secure message to the service.
 * This function looks into the modal dialog passed into it and fecthes the form data and posts the same to the service.
 * If the function is successfull it would fade in the success view, if an error is thrown by the service, it would display the error view.
 * We also hide the scroll bar in the textarea if there is one, to reolve scroll bar lagging issue in XP. 
 * 
 * Usage: Called from the replyMessage.js, compose.js and dispute.js to post the sendMessage details to the KANA service behind the scenes.
 * 
 *  Args: 
 *     modal : This is the from model we show the user for Reply/Compose/Dispute.
 *     textAreaId: id of the text area in the form.
 * 
 */
function postSecureMessage($modal, textAreaId) {
    var $form = $modal.find("form");
    var $modalContent = $modal.find(".content > .content-wrapper");
    var url = $form.attr("action");
    
    var formData = {};
    $.map($form.serializeArray(), function(n, i) {
        formData[n.name] = n.value;
    });
    
    $.post(url, formData, function(data, textStatus, jqXHR) {
        var hasErrors = (jqXHR.getResponseHeader('hasErrors') === 'true');
        var $newContent = $("<div>").addClass('content-wrapper').html(data);
        
        // On success, we will fade out & fade in the confirmation.
        // Otherwise, just swap in the errors
        if (hasErrors) {
            $modalContent.replaceWith($newContent);
            applyFormalize();
            $(".modal .content").scrollTop(0);
            setTimeout(function(){
            	$(".modal .error").focus();  
            },100); 
            $(textAreaId).trigger('input');
            return;
        }
        // Lock the height so it does not expand (contracting is ok) when we transition to the new content
        var $content = $modal.find(".content");
        var height = $content.height();
        $content.css("max-height", height + 'px');
        // XXX Workaround for chrome scrollbars flashing on fades in windows xp
        // See http://code.google.com/p/chromium/issues/detail?id=24524
        // This was supposedly fixed, but the "fix" doesn't seem to work.
        // The workaround is: hide the scrollbar...
        $(textAreaId).css("overflow-y", "hidden");
        $modalContent.fadeOut(200, function() {
            $modal.find(".content").append($newContent); 
            $(".modal .content").scrollTop(0);
            setTimeout(function(){
            	$(".modal .success").focus();
            },100);	
            $modalContent.remove();
            messageSent=true;
        });
    });
}

/**
 * This function pre-loads the spinner image used by the green buttons on the page
 */
function preloadSpinner() {
    $('<img/>')[0].src = '/assets/images/spinner_white_on_green.gif';
}